package config

type InputConfiguration struct {
	Name string `json:"name,omitempty" yaml:"name,omitempty" mapstructure:"name"`
	Path string `json:"path" yaml:"path" mapstructure:"path"`

	Replacements []string `json:"replacements,omitempty" yaml:"replacements,omitempty" mapstructure:"replacements"`
	Acronyms     []string `json:"acronyms,omitempty" yaml:"acronyms,omitempty" mapstructure:"acronyms"`
}

type PackageConfiguration struct {
	Name   string `json:"name" yaml:"name" mapstructure:"name"`
	Output string `json:"output" yaml:"output" mapstructure:"output"`

	Replacements []string `json:"replacements,omitempty" yaml:"replacements,omitempty" mapstructure:"replacements"`
	Acronyms     []string `json:"acronyms,omitempty" yaml:"acronyms,omitempty" mapstructure:"acronyms"`

	Inputs []InputConfiguration `json:"inputs" yaml:"inputs" mapstructure:"inputs"`
}

type Configuration struct {
	Packages []PackageConfiguration `json:"packages" yaml:"packages" mapstructure:"packages"`
}
