package config

import (
	"fmt"
	"os"
	"path"

	"github.com/spf13/viper"
)

func Read(paths ...string) (*Configuration, string, error) {
	viper.AutomaticEnv()

	viper.SetConfigName(".gotygen")
	viper.SetConfigType("yaml")

	for _, in := range paths {
		viper.AddConfigPath(in)
	}
	if workDirPath, err := os.Getwd(); err == nil {
		viper.AddConfigPath(workDirPath)
	}

	if err := viper.ReadInConfig(); err != nil {
		return nil, "", err
	}

	fmt.Println(viper.ConfigFileUsed())

	var config Configuration
	if err := viper.Unmarshal(&config); err != nil {
		return nil, "", err
	}
	return &config, path.Dir(viper.ConfigFileUsed()), nil
}
