package strcase

import (
	"testing"

	"github.com/stretchr/testify/assert"
)

func TestToCamel(t *testing.T) {
	assert.Equal(t, "", ToCamel(""))
	assert.Equal(t, "T", ToCamel("t"))
	assert.Equal(t, "To", ToCamel("to"))
	assert.Equal(t, "ToCamelCase", ToCamel("to camel  case  "))
	assert.Equal(t, "ToCamelCase", ToCamel("to_camel__case"))
	assert.Equal(t, "ToCamelCase", ToCamel("to-camel--case"))
	assert.Equal(t, "ToCamelCase", ToCamel("to_camel -case"))
	assert.Equal(t, "JsonToGo", ToCamel("JSON to Go"))

	ctx := NewCamelContext([]string{"ID", "JSON"})
	assert.Equal(t, "ID", ToCamel("id", ctx))
	assert.Equal(t, "JSON", ToCamel("json", ctx))
	assert.Equal(t, "JSONToGo", ToCamel("JSON to Go", ctx))
}
